package ru.cleptoman.flv.flvmetadata {
	/**
	 * ...
	 * @author Aleksey Kutov aka cleptoman
	 */

	import flash.utils.ByteArray;
	import ru.cleptoman.flv.utils.BytesUtils;

	public class FLVMetaData {
		
		public var duration:uint;
		public var width:Number;
		public var height:Number;
		public var framerate:Number;
		public var videocodecid:Number;
		public var canSeekToEnd:Boolean;
		public var audiocodecid:Number;
		public var creationdate:String;
		
		public function FLVMetaData() {
			canSeekToEnd = true;
			
		}
		public function getBytes():ByteArray {
			var ba:ByteArray = new ByteArray();
			ba.writeByte(2);
			BytesUtils.writeUnsignedInt16(ba, "onMetaData".length);
			ba.writeUTFBytes( "onMetaData" );
			ba.writeByte(8);
			ba.writeUnsignedInt(7);
			var propCount:uint = 0;
			var prop:String;
			
			getStringProp(ba, "creationdate", creationdate);
			getNumberProp(ba, "duration", duration);
			getNumberProp(ba, "width", width);
			getNumberProp(ba, "height", height);
			getNumberProp(ba, "framerate", framerate);
			getNumberProp(ba, "videocodecid", videocodecid);
			getBoolProp(ba, "canSeekToEnd", canSeekToEnd);
			getNumberProp(ba, "audiocodecid", audiocodecid);

			BytesUtils.writeUnsignedInt24(ba, 9);
			return ba;
		}
		
		private function getStringProp(bytes:ByteArray, prop:String, value:String):void {
			BytesUtils.writeUnsignedInt16(bytes, prop.length);
			bytes.writeUTFBytes(prop);
			bytes.writeByte(2); // string 
			BytesUtils.writeUnsignedInt16(bytes, this[prop].length);
			bytes.writeUTFBytes(this[prop]);
		}
		private function getNumberProp(bytes:ByteArray,prop:String, value:Number):void {
			BytesUtils.writeUnsignedInt16(bytes, prop.length);
			bytes.writeUTFBytes(prop);
			bytes.writeByte(0); //Number
			bytes.writeDouble(this[prop]);
		}
		private function getBoolProp(bytes:ByteArray,prop:String, value:Boolean):void {
			BytesUtils.writeUnsignedInt16(bytes, prop.length);
			bytes.writeUTFBytes(prop);
			bytes.writeByte(1); // boolean 
			bytes.writeByte(int(this[prop]));
		}
		
	}
}